# *Modular Remastered*

A complete overhaul of the old __Modular__ from the ModWorkShop era, this character cannot use any weapons other than their starter, but gain __unique passive upgrades__ that lets them expand their abilities. 

![Potential.](https://cdn.discordapp.com/attachments/1040071589460451388/1121943545138393138/ModularGunAnimation.gif)

This mod contains:
- A whole new character!

- Up to __65+__ new passive upgrades unique to the Modular, which have stacking capabilities.
![There's more!](https://cdn.discordapp.com/attachments/1040071589460451388/1121945705800548415/image.png)

- Multiple unlocks that are __unique__ to the Modular. Maybe try a __playstyle change__ every once in a while?

![Treasure Trove](https://cdn.discordapp.com/attachments/1040071589460451388/1121948245048955070/Options.gif)

- Character-specific synergies, displayed with an arrow above the item. Some items aren't as __useless as they many seem__.

![Wow!](https://cdn.discordapp.com/attachments/1040071589460451388/1121944276645970022/ModularSynergyAnimation.gif)

- __An unlockable alternate skin__- wait what?

![Corrupted Data](https://cdn.discordapp.com/attachments/1040071589460451388/1121944959017291776/image.png)

- __And, most importantly...__


# ... A Regret..?

![There's more!](https://cdn.discordapp.com/attachments/1040071589460451388/1121947290748325899/ARegret.gif)


# Special Thanks To:
- Lynceus, my play tester and advice giver. A lot of bugs and issues were found and fixed thanks to him! He has also sprited a lot of small icons that you can find in the mod!
- Docmcstuffins (gave idea for the Mirrored Software Module)
- Stavbearer (gave idea for the Hellfire Launcher Module)
- June (main inspiration behind a certain new module)

# V.1.1.10

- Changed code in Singularity Pulsars rift projectiles to clear distortion if they stick to a surface via sticky projectile behaviors.
- Fixed typo in Past Bosses dialogue.
- Another few very small things

# V.1.1.9

# Changes
- If a sticky projectile effect is rolled by Chance Bullets while playing as Modular, it should now function properly.
- Added A

# V.1.1.8
- Hopefully fixed weird issue with somehow getting every alt weapon at once.
- Placed alternate Singularity Pulsar variant into excluded tier.
- Tweaked carry offset of the alternate default arm cannon.
- Fixed several visual issues with the alternate Light Lance variant.

# V.1.1.7

# New
- Added new item: Predefined Drive

# Changes
- Overhauled the first 2 rooms of the Modulars Past, with new decoratives, and other things.
- Added a few small things. :)
- Added some special icons in certain places, spritework courtesy of Lynceus.

# Fixes
- A few small things


# V.1.1.6

- EVEN MORE CO-OP FAILSAFES I CANT FUCKING TEST PROPERLY.
- FUCK.

# V.1.1.5

- Another minor UI tweak.
- A module fix.
- Don't ever ask me to fix that god damned UI again.

# V.1.1.4
- Globalized Scrap pickups because i forgot coop players share pickups
- Added coop failsafe to Modulars past where non-modular characters get a dart gun
- All of modulars starters should now persist past death in co-op
- Hopefully fixed potential visual bug if a gun that was indicated to be turned into modules was picked up by another player
- Tweaked modular inventory size scaling based on screen resolution, hopefully for the last fucking time
- Fixed cleaning protocol breaking the game against Dragun


- Please never ask me about controller support. Please.

# V.1.1.3

#### Fixes:
- Fixed Page turn button not working due to an oversight
- Cleaned up error from selecting modules occasionally
- Hopefully fixed weird sprite offset with cleaning protocol
- Fixed bug where pausing and unpausing after crafting would recraft modules for free

#### Misc:
- Tweaked Nopticon body hitbox
- Temporary Module counts are now displayed with an orange color to be more consistent with the rest of the UI

# V.1.1.2

- Kill me.
- Fixed a thing idk im tired of this already

# *V.1.1.1*

#### Fixes:
- Fixed Confidence Drives being repeatedly encounterable in the shop as Modular.
- Updated README
- Fixed a bug with blessed mode modular that would remove weapons when it shouldnt
- Hopefully fixed bug with temporary modules that makes them not go away if you got 2 of the same temporary module
- Fixed Artemis and Apollo not scaling with fire rate upgrades like intended
- Fixed Artemis And Apollo just, not fucking working properly at all


# *V.1.1.0*

#### New Item
- Confidence Drive (Unlocked by beating the Dragun as Modular)


#### New Modules
- Heavyweight Rounds
- Cleaning Protocol
- Phantasm Boost
- Heat Vectoring
- Table Kinetics
- Tank Carapace
- [TO_DO, Remember to fill this one out!!!]
- [???]

#### Blessed Mode
- Now functions completely uniquely for the Modular. Give it a try! 


#### Quality Of Life

- Modules that affect rate of fire now affect how fast charge weapons charge.
- Added new button to the Module Inventory that displays tips.
- Added minimap icons for Modules, Scrap and Crafting Cores.
- Updated gun nudge mechanic into a proper gun tethering mechanic
- Tweaked Power Capacity text box in the Module Inventory to make it more clear that it's interactable.


#### Module Changes

##### Machine Instinct
- Lowered Risk buildup speed
- Increased ability cooldown from 5s => 10s 
- (Note: 5 seconds was too low what was I thinking lol)
##### The Scavenger
- Replaced extra scrap from scrapping mechanic with the ability to scrap guns.
- Reduced movement bonus from 5% => 2.5%
- (Note: This module was always a free take as it benefitted you 99% of the time. By giving you a choice it should now be less of a guaranteed pick, and actually gives a bit of extra thought to scrapping.)
##### Laser Lance
- Increased Laser Lance laser damage
- Removed 1 Bounce
##### Burning Hell
- No longer reduces clip size.
- Added new Accuracy bonus
##### Rubber Fillings
- Increased bounce count from 1 (1) => 2 (2)
- Added slight accuracy penalty
##### Repair Kit
- Damage reduced back to 15% (15%)
- Energy cost lowered from 1 (0.5) => 0.5 (0.25)
##### Aggresive Reload
- Can now push away projectiles, with precise timing.
##### Reactive Sensors
- Can now push away projectiles, with precise timing.
##### One Shot
- Fixed rounding in the stat processing, should now consistently apply its +1 Clip size benefit.
##### Sticky Bomb
- Tweaked detonation time to be more true to its description.
##### Recycling Nanites
- Should now have a sound effect and visual effect when triggered.
##### Impact Power
- Increased bounce count from 1 => 2
##### Glass Generator
- Grants a small fire rate bonus per Glass Guon Stone.
- (Note: This module is good, but was always left off until needed. This incentives keeping it active a bit more.)
##### Mercy Rounds
- Now spread the slain enemies debuffs when the enemy is killed.
- (Note: This module was always very niche, but along with a new module and this buff it should see more use now.)
##### Patient Zero
- Added effect blacklist to its hit-effect
- (Note: The blacklist was present for the on-kill effect, but not the on-hit. Oops.)
##### Misc.
- Altered the rarity of some special modules.

##### Past
- Increased Past boss HP from 550 => 675

##### Fixes

- Fixed the weapon crates hitbox being stupidly large.
- Fixed weird sprite offset with Burning Hell module.
- Fixed Regenerative Plating having its effect values switched around. It should now give stacking armor per floor and a consistent 1 Armor when scrapping. 

# V.1.0.11

- Fixed Mirrored Software picking modules that the player did not have active, negating Mirrored Softwares effect completely.

- Perfect Replica has had some VFX added.

- AAAAAAAAAAAAAAAAAAAAAAAAAA

# V.1.0.10

- Removed weird screenshake from the Hammer hopefully kill meeeeeeeee

# V.1.0.9

# Fixes

- Pea Shooter now gives the intended 1 Additional Power instead of 2. 
(*Note: It used to be 2 while in development but I decided to change it to one at some point, but forgot to update the weapons power stat.*) 

- Gone over every module necessary and added a check to hopefully prevent them from breaking on the Dragun fight.

- Laser Lance lasers should now follow sticky projectiles properly.

- Sticky projectiles with bouncing properties should hopefully not act weird anymore when hitting a wall sometimes.

- Voltaic Tethers should hopefully no longer throw out errors.

- Aggressive Reload should now have a sound effect, like it was always supposed to have.


## Module Changes

- Monetary Value

-- Casings gained per floor no longer scales with the amount of stacks of Monetary Value you have.

-- Casings gained per floor increased from 1.2x -> 1.25x

-- Note (*As funny as this module is, it gives very easy multiplicatively growing power for very cheap*)


- The Scavenger

-- Readded the damage bonus. Now gives 5% (+5%) damage per Scrap. 

-- Additional Scrap gains no longer scale with how many stacks of The Scavenger you have.

-- Clip size bonus now works like other clip size multipliers.

-- (*Note: with how good it was on release, and with how many times I've changed it already, I dont want it to be an instant take, but also dont want it to be hot garbage, so I readded the damage up to counterbalance all other nerfs it has gotten. Though it'll likely still stay an instant-take by most. :P*)


- Regenerative Plating

-- Armor gain when scrapping pickups no longer scales with the amount of Regenerative Platings you have. 

-- (*Note: the change to Regenerative Plating giving Armor when scrapping was done very late, and I forgot to consider that players will end up scrapping a lot more than floors they clear. This change still makes it usable but now Regenerative Platings main feature IS the armor per floor.*)

- Repair Kit

-- Damage bonus increased from 15% (15%) to 20% (20%).

-Disabled Dampeners

-- Made its recoil scale a lot less with your projectiles damage.

-- (*Note: I don't expect people to always genuinely consider taking this module, but it should hopefully be a bit more usable now.*)


- The Swarm

-- Stacking should now provide a tighter turn angle and detection radius

- Redirect System

-- Projectiles fired with Redirect System now have a "dead time" of 0.15 seconds when they spawn where they cannot be affected by redirects.

-- (*Note: this change will only really be noticeable with shotguns, as it prevents the projectiles from clustering up into a ball.*)

- Voltaic Tethers

-- Changed max connections from 2 -> 3

- Laser Lance

-- Should now function more intuitively with sticky projectiles.

- Recycling Nanites

-- Damage increase per hit increased from 3.3% -> 5%

# V.1.0.8

- Fixed the Past having no music because Gungeon code is stupid.
- Tweaked RNG Manipulation.

# V.1.0.7
- Fixes
- Fixed Monetary Value literally not doing anything

- Module Changes

- Disabled Dampeners
- Reduced recoil from Disabled Dampeners
- Buffed reload time decrease from 10% to 12.5%

- Hyper Propellant
- Rewritten the air ignition code, ignition effect should now consistently ignite the air regardless of projectile speed

- Radar Scanner
- Now reveals secret rooms if you are in an adjacent room to it

- Concussive Tips
- Fixed inaccurate knockback stat description

-Tweaked a couple of descriptions.

# V.1.0.6
- Hopefully prevented the starter active item from every being dropped. The work around is kinda jank and *may* break so tell me if it does and how.

# V.1.0.5
- Modules Changes

--Overclocked Magazines
-Reduced spread multiplier from 3x -> 2.5x

--Five-Shot Salute
-Buffed stacking effect from +1 Projectile to +2 Projectiles

--Voltaic Tethers
- Added ability for projectiles to pierce enemies
- Added ability for projectiles pierce small debris
- Tether nodes can only have a MAXIMUM of 2 Connections, to prevent lag.
- Buffed damage from 12 DPS -> 15 DPS
- Increased node-to-node range

--Lightning Nets
- Slightly increased tether range
- Tethers can now only have a MAXIMUM of 3 Connections, to prevent lag

--Mercy Rounds
- Buffed damage donus from 33% (+33%) -> 50% (+50%)

--Impact Power
-Fixed incorrect scaling damage value in its description.

--The Marksman
- Fixed incorrect Ammonomicon entry.

- Fixes
- Hopefully fixed flickering in the UI when picking up casings.
- Hopefully made the cursor visible on controller in the Gun Selection UI


# V.1.0.4
- Features
- Added new synergy with the Sprun.

- Module Changes

--The Swarm
- To slightly compensate for a fix, The Swarm has recieved a very minor damage buff.

--Ultra Ricochet
- Now doubles player projectile speed.

--Bubble Blast
- Projectiles will be reduced to 6.66% of their base speed instead of 10%.
- After reloading, projectiles will be 25% faster than their base speed.

--The Scavenger
- Removed damage bonus completely.
- Increased energy usage from 1 (0.5) to 2 (1)
- Reduced movement speed bonus from 10% to 5%

- Changes
- The game can now be paused in the Inventory UI. This will automatically close the UI.
- Changed some text to fit more appropriately to what the story of the Modular is.

- Fixes
- Fixed Modules not being lost when entering the Past, hopefully.
- Fixed Regenerative Plating from not granting the armor bonus when scrapping pickups or items.
- Fixed Ultra Ricochets explosions from dealing damage.
- Fixed unintentional damage scaling with The Swarm.
- Fixed a grammatical error in Emergency Reponse

# V.1.0.3
- Fixed a small oversight that could prevent certain inventory-based UI elements from disappearing properly.
- Added the ability to pierce through small debris objects to various unlockables.
- Added basic item tips support, mostly for some certain synergies.

# V.1.0.2
- Improved pickup detection logic for the Scrapper.
- Fixed the effect of a module from causing game-breaking errors.
- Removed some debug logging where there shouldn't be.

# V.1.0.1
- Updated README.

# V 1.0.0
- Initial release.




